#include <avr/io.h>
#include <avr/eeprom.h>			
#include <avr/interrupt.h>  /* for sei() */
#include <util/delay.h>     /* for _delay_ms() */
#include <avr/pgmspace.h>   /* required by usbdrv.h */
#include "usbdrv.h"

#define RQ_SET_LED    0
#define RQ_GET_SWITCH 1
#define RQ_GET_LIGHT 2
/* ------------------------------------------------------------------------- */
/* ----------------------------- USB interface ----------------------------- */
/* ------------------------------------------------------------------------- */
int ind=0;
int ii=0;
int8_t ss,sh,sm;

void remember(uint8_t ,uint8_t , uint8_t);
void getTime(int id, uint8_t *hh , uint8_t *mm , uint8_t *ss);
usbMsgLen_t usbFunctionSetup(uint8_t data[8])
{
    usbRequest_t *rq = (void *)data;
    static uint8_t switch_state;  
    static uint16_t light_state;
    static uint32_t rettest;
    static uint8_t time_ret[100][3];
    int tmp;
   if(rq->bRequest == 7) {
	tmp=0;
	__EEGET(ind , 0 );
	for( ; tmp<ind ; tmp++)
		getTime( tmp , &time_ret[tmp][0] , &time_ret[tmp][1] ,&time_ret[tmp][2]);
	rettest = sizeof(int);
	usbMsgPtr = (void)*time_ret;
	return 3*ind;
}
return 0;

void remember(uint8_t s , uint8_t m ,uint8_t h) {
	__EEGET(ind,0);
	if(ind ==100) return ;
	__EEPUT(ind*3+1 ,s);
	__EEPUT(ind*3+2 ,s);
	__EEPUT(ind*3+3 ,s);
	ind++;
	__EEPUT(0,ind); }
void getTime(int id,uint_8_t *hh , uint8_t *mm , uint8_t *ss) {
	if(id <0 ) return;
	if(id>99) return;
	__EEGET(*hh, id*3 +1 );
	__EEGET(*mm,id*3+2);
	__EEGET(*ss,id*3+3);
}
int main(void) 
{
 	unsigned int i,j;
 	int chp =0;
	DDRC &= 0b11111010;
	PORTC |= 0b00000101;
	
  usbInit();
  usbDeviceDisconnect();
  _delay_ms(300);
  usbDeviceConnect();
  
  sei();
  ii = 0 ; 
  ss=0;
  sh=0;
  sm=0;
  	for(;;)
	{
		if((PINC & (1<<PC2)) ==0)
		{
			__EEPUT(0,0);
			ii=0;
			ss=0;
			sm=0;
			sh=0;	
		}
		if((PINC& (1<<PC0)) ==0 && chp ==0)
		{
			chp=1 ;
			remember(ss,sm,sh);
		}
		if(ii%200 ==0) chp=0,ii=0;
usbPoll();
_delay_ms(10);
ii++;
if(ii%100==0) {
	ss++;
	if(ss%60==0) {
	sm++; ss=0;
		if(sm%60 ==0) sh++,sm=0;
		}
	}
}
return 0;
}
